---
title: "Step 5: Assign a resource grant to the web application"
component: pingone-api
page_id: pingone-api:workflow-library:pingone-authorize/show-permissions-in-token/environment-configuration/step-5-assign-a-resource-grant-to-the-web-application
canonical_url: https://developer.pingidentity.com/pingone-api/workflow-library/pingone-authorize/show-permissions-in-token/environment-configuration/step-5-assign-a-resource-grant-to-the-web-application.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Step 5: Assign a resource grant to the web application

##

   

```none
POST {{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants
```

The `POST {{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/grants` operation creates a new resource access grant for the application.

The body of the request specifies the ID for the `resource` property (your new custom resource) and the ID for the scope (your new custom scope) that you will assign to the application's resource grant.

The response shows the resource grant ID and the scope associated with the grant.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "resource": {
        "id": "{{customResourceID}}"
    },
    "scopes": [
        {
            "id": "{{customResourceScopeID}}"
        }
    ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "resource": {
        "id": "{{customResourceID}}"
    },
    "scopes": [
        {
            "id": "{{customResourceScopeID}}"
        }
    ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""resource"": {" + "\n" +
@"        ""id"": ""{{customResourceID}}""" + "\n" +
@"    }," + "\n" +
@"    ""scopes"": [" + "\n" +
@"        {" + "\n" +
@"            ""id"": ""{{customResourceScopeID}}""" + "\n" +
@"        }" + "\n" +
@"    ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants"
  method := "POST"

  payload := strings.NewReader(`{
    "resource": {
        "id": "{{customResourceID}}"
    },
    "scopes": [
        {
            "id": "{{customResourceScopeID}}"
        }
    ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "resource": {
        "id": "{{customResourceID}}"
    },
    "scopes": [
        {
            "id": "{{customResourceScopeID}}"
        }
    ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"resource\": {\n        \"id\": \"{{customResourceID}}\"\n    },\n    \"scopes\": [\n        {\n            \"id\": \"{{customResourceScopeID}}\"\n        }\n    ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "resource": {
      "id": "{{customResourceID}}"
    },
    "scopes": [
      {
        "id": "{{customResourceScopeID}}"
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "resource": {
      "id": "{{customResourceID}}"
    },
    "scopes": [
      {
        "id": "{{customResourceScopeID}}"
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants"

payload = json.dumps({
  "resource": {
    "id": "{{customResourceID}}"
  },
  "scopes": [
    {
      "id": "{{customResourceScopeID}}"
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "resource": {\n        "id": "{{customResourceID}}"\n    },\n    "scopes": [\n        {\n            "id": "{{customResourceScopeID}}"\n        }\n    ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "resource": {
    "id": "{{customResourceID}}"
  },
  "scopes": [
    {
      "id": "{{customResourceScopeID}}"
    }
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"resource\": {\n        \"id\": \"{{customResourceID}}\"\n    },\n    \"scopes\": [\n        {\n            \"id\": \"{{customResourceScopeID}}\"\n        }\n    ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/applications/{{customResourceAppID}}/grants")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/applications/d2174a86-53ed-4d4b-90d7-3e0fed0d4985/grants/59faaee9-c28a-476f-abdd-19aa3f70321a"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "application": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/applications/d2174a86-53ed-4d4b-90d7-3e0fed0d4985"
        },
        "resource": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/resources/5de5451f-47e8-44f5-946d-6d8936685704"
        }
    },
    "id": "59faaee9-c28a-476f-abdd-19aa3f70321a",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "resource": {
        "id": "5de5451f-47e8-44f5-946d-6d8936685704"
    },
    "application": {
        "id": "d2174a86-53ed-4d4b-90d7-3e0fed0d4985"
    },
    "scopes": [
        {
            "id": "82f89459-1a10-42eb-9cf8-86fba8290cb7"
        }
    ],
    "createdAt": "2024-04-12T19:33:09.848Z",
    "updatedAt": "2024-04-12T19:33:09.848Z"
}
```
